/* Problem URL: https://codeforces.com/problemset/problem/1976/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    int lim[] = {n, m};

    V<array<int, 2>> a(n + m + 1);
    vi team(n + m + 1);
    rep(i, n + m + 1) {
        cin >> a[i][0];
    }
    rep(i, n + m + 1) {
        cin >> a[i][1];
        team[i] = a[i][1] > a[i][0];
    }

    vi pref0(n + m + 2);
    vi pref1(n + m + 2);

    nrep(i, 1, n + m + 2) {
        pref0[i] = pref0[i - 1] + (team[i - 1] == 0);
        pref1[i] = pref1[i - 1] + (team[i - 1] == 1);
    }

    int lim0 = (int)(upper_bound(all(pref0), n) - pref0.begin()) - 1;
    int lim1 = (int)(upper_bound(all(pref1), m) - pref1.begin()) - 1;

    int lims[] = {lim0, lim1};
    ll cou[] = {0, 0};

    ll ans = 0;
    for (int i = n + m; i >= 0; i--) {
        if (i > lims[team[i]]) {
            ans += a[i][team[i]^1];
            continue;
        }

        if (i == lims[team[i]]) {
            cou[team[i]] = a[i][team[i]];
            cou[team[i]^1] = a[i][team[i]^1];
            continue;
        }

        ans += a[i][team[i]];
    }

    rep(i, n + m + 1) {
        if (i < lims[team[i]]) {
            cout << ans - a[i][team[i]] + cou[team[i]] << ' ';
            continue;
        }

        if (i == lims[team[i]]) {
            cout << ans << ' ';
            ans += a[i][team[i]^1];
            cou[0] = 0;
            cou[1] = 0;
            continue;
        }

        cout << ans - a[i][team[i]^1] << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
